/* 
 * File:   fm:ReadConfig
 * Autor: Strelok Vlad Kolerts
 *
 * Created on Martch 16, 2009, 2:19 AM
 */
	
#include <ZConfig.h>
#include <vector>
/*
struct plugin_struct
{
	QString name;
	int id;
	int type;
};

struct mime_struct
{
	QString type;
	int app;
	int pm;
};*/

std::vector<plugin_struct> plugins;
std::vector<mime_struct> mimes;
int plug_nums;
int mime_nums;

QString work_folder;
QString path_tab1="/";
QString path_tab2="/";
QString lang;
bool full_inf=0;
bool full_scr=1;
int header_type=3;
int thumbnail_size=32;


void readConfig(QString progDir)
	{
		//qDebug("read config file: "+progDir+"fm.cfg");
		
		ZConfig fm_cfg(QString("%1fm.cfg").arg(progDir), true);
		work_folder=fm_cfg.readEntry("Setting", "Work_folder", "");
		path_tab1=fm_cfg.readEntry("Setting", "Start_path_tab1", "/");
		path_tab2=fm_cfg.readEntry("Setting", "Start_path_tab2", "/");
		lang=fm_cfg.readEntry("Setting", "Language", "");
		full_inf=fm_cfg.readBoolEntry("Setting", "Full_info", 0);
		full_scr=fm_cfg.readBoolEntry("Setting", "Full_screen", 1);
		header_type=fm_cfg.readNumEntry("Setting", "Header_type", 3);
		thumbnail_size=fm_cfg.readNumEntry("Setting", "Thumbnail_Size", 32);
		
		//qDebug("work folder: "+work_folder);
		//qDebug("Start_path_tab1: "+path_tab1);
		//qDebug("Start_path_tab2: "+path_tab2);
		//qDebug("Language: "+lang);
		//qDebug(QString("Full_screen: %1").arg(full_scr));
		//qDebug(QString("Header_type: %1").arg(header_type));
		//qDebug(QString("Full_info: %1").arg(full_inf));
	}
/**
int plug_num=0;
QStringList plug_id;
QStringList plug_path;
QStringList plug_name;
QStringList plug_icon;
QStringList plug_type;
QStringList plug_arg;*/
	
void FM::PluginConfig()
	{
		/**QStringList plugins;
		ZConfig plug_cfg(work_folder+"/fm_plugins_new.cfg", true);
		plug_cfg.getGroupsKeyList(plugins);
		plug_num=plugins.count();
		
		//system("echo \""+QString("Plug num: %1").arg(plug_num)+"\" > /mmc/mmca1/plugins.txt");
		
		for (int i=0; i<plug_num; i++)
		{
			plug_id.append(plug_cfg.readEntry(plugins[i], "ID", ""));
			plug_path.append(plug_cfg.readEntry(plugins[i], "Path", ""));
			plug_name.append(plug_cfg.readEntry(plugins[i], "Name", ""));
			plug_icon.append(plug_cfg.readEntry(plugins[i], "Icon", ""));
			plug_type.append(plug_cfg.readEntry(plugins[i], "Type", ""));
			plug_arg.append(plug_cfg.readEntry(plugins[i], "Args", ""));
			
			if(plug_path[i].left(1)!="/" && plug_path[i]!="")
				plug_path[i]=work_folder+plug_path[i];
			if(plug_icon[i].left(1)!="/" && plug_icon[i]!="")
				plug_icon[i]=work_folder+plug_icon[i];
			
		}*/
		/*
			system("echo \"["+plugins[i]+"]\" >> /mmc/mmca1/plugins.txt");
			system("echo \"ID:"+plug_id[i]+"\" >> /mmc/mmca1/plugins.txt");
			system("echo \"Path:"+plug_path[i]+"\" >> /mmc/mmca1/plugins.txt");
			system("echo \"Name:"+plug_name[i]+"\" >> /mmc/mmca1/plugins.txt");
			system("echo \"Icon:"+plug_icon[i]+"\" >> /mmc/mmca1/plugins.txt");
			system("echo \"Type:"+plug_type[i]+"n/\" >> /mmc/mmca1/plugins.txt");*/
		
		plugin_struct tmp;
		QString temp_line;
		
		QFile file(work_folder+"/fm_plugins.cfg");
		if( file.open(IO_ReadOnly) )		
		{
			QTextStream stream( &file );			
			while(temp_line=stream.readLine())
			{
				tmp.id=atoi(temp_line.mid(0,2));
				tmp.type=atoi(temp_line.mid(3,1));
				tmp.name=temp_line.mid(5,100);
				
				plugins.push_back(tmp);
				plug_nums++;
			}
			file.close();	
		}
	}

void FM::MimeConfig()
	{
		mime_struct tmp;
		QString temp_line;
		
		QFile file(work_folder+"/mime_types.cfg");
		if( file.open(IO_ReadOnly) )		
		{
			QTextStream stream( &file );			
			while(temp_line=stream.readLine())
			{
				tmp.pm=atoi(temp_line.mid(0,3));
				tmp.app=atoi(temp_line.mid(4,2));
				tmp.type=temp_line.mid(7,20).upper();
				
				mimes.push_back(tmp);
				mime_nums++;
			}
			file.close();	
		}
	}

void FM::BookmarkConfig()
	{
		QFile file_bm(work_folder+"/bookmark.cfg");
		if( file_bm.open(IO_ReadOnly) )		
		{
			QString temp_line;
			QTextStream stream( &file_bm );
			stream.setEncoding ( QTextStream::UnicodeUTF8 );
			while(temp_line=stream.readLine())
			{
				if(temp_line=="")
					temp_line=stream.readLine();
				bm_name.append(temp_line);
				temp_line=stream.readLine();
				bm_path.append(temp_line);
			}
			file_bm.close();	
		}
	}
	
