//
// C++ Implementation: ZFileBrowserFtab
//
// Description:
//
//
// Author: root <root@andLinux>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "FileBrowserFtab.h"

#include <vector>

extern QDaemonApp* a;
extern QString work_folder;

extern std::vector<mime_struct> mimes;
extern int mime_nums, thumbnail_size;

class ZListBox;

FileBrowserFtab::FileBrowserFtab (bool FullInfo, QString arg1, QWidget* arg2, unsigned int arg3, ZSkinService::WidgetClsID arg4 ): ZListBox ( arg1, arg2, arg3, arg4 )//(ZSkinService::WidgetClsID)0
{
	FullInf=0;
	ActItem=0;
	pre_i=0;
	sFileName = "";
	multi_sel=false;
	FListType="%I%M";
	nameFilter = "*";
	FullInf=FullInfo;

	prev_timer = new QTimer(this);
	connect( prev_timer, SIGNAL(timeout()), SLOT(LoadPreview()) );
	connect ( this, SIGNAL ( highlighted ( int ) ), this, SLOT ( itemHighlighted ( int ) ) );
	connect ( this, SIGNAL ( selected ( int ) ), this, SLOT ( itemSelected ( int ) ) );

	//work_folder = getProgramDir ( QString ( a->argv() [0] ) );
	OnlyDirs = false;

	/*pm_link[0]=QPixmap(work_folder+"res/img/browser/0/"+IDB_SYMLINK);
	pm_link[1]=QPixmap(work_folder+"res/img/browser/1/"+IDB_SYMLINK);*/

	QPixmapCache::setCacheLimit(1024*5);
}

FileBrowserFtab::~FileBrowserFtab()
{
}

void FileBrowserFtab::setDir ( const QString &sPath, int act_item )
{
	if(pre_i>0) prev_timer->stop();pre_i=0; pre_next=true;
	if(FullInf==1)  prev_timer->start( 50 );
	
	/*QFont font(NULL,16,87,false);
	QFont font1(NULL,16,25,false);*/
	QFont font=this->font();
	//font.setPixelSize(font.pixelSize() - 7);

	QDateTime date_time;
	QString label2, fSize;
	double size;
	bool isBack = true;
	this->clear();
	  qDebug("fb::set path "+sPath);
	QDir dir ( sPath, nameFilter );
	
	/** VARIANT 1*
	QFileInfo		fInfo;
	DIR				*dp;
	struct dirent	*file;
	
	dp = opendir( QFile::encodeName(sPath) );
	while ( (file = readdir(dp)) != NULL ) 
	{
		if ( strcmp(file->d_name,"." ) == 0 || strcmp(file->d_name,".." ) == 0 )
			continue;
		isBack = isBack && true;

		QString fn = QFile::decodeName(file->d_name);
		fInfo.setFile( dir, fn );
		date_time=fInfo.lastModified();
		ZListBoxItem* Item = new ZListBoxItem ( this, QString ( FListType ) );
		
		if(fInfo.isDir())
		{
			if(!fInfo.isSymLink())
				loadPic(pixmap, QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER).arg(FullInf));
				//pixmap.load(QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER).arg(FullInf));
			else
				loadPic(pixmap, QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER_LINK).arg(FullInf));
				//pixmap.load(QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER_LINK).arg(FullInf));
			//if(fInfo.isSymLink())
			//	PmLink();
			label2=fDate(date_time);
			
		}
		else if (fInfo.isFile())
		{
			if(!fInfo.isSymLink())
			{
				loadPic(pixmap, QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE).arg(FullInf));
				//pixmap.load(QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE).arg(FullInf));
				QString mime;
				mime=get_Mime(fn);
				for (int i=0;i<mime_nums;i++)
				{
					if(mime==mimes[i].type)
					{
						pixmap.load(work_folder+QString("res/img/mime/%1/%2.png").arg(FullInf).arg(mimes[i].pm));
					}
				}
			}
			else
				loadPic(pixmap, QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE_LINK).arg(FullInf));
				//pixmap=QPixmap(QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE_LINK).arg(FullInf));
			// mime detect pic
			
			size=fInfo.size();
			if(size < 1024)
				fSize=QString("%1 b").arg(size);
			else if(size < 1024 * 1024)
				fSize=QString("%1 Kb").arg(floor(size/1024*100)/100);
			else
				fSize=QString("%1 Mb").arg(floor(size/1024/1024*100)/100);
			
			label2=fSize+"\t\t\t"+fDate(date_time);
		}
		else
		{
			pixmap=QPixmap(QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_DEV).arg(FullInf));
			label2=fDate(date_time);
		}
		
		Item->setPixmap ( 0, pixmap );
		Item->appendSubItem ( 1, fn, false, NULL );
		if(!date_time.isNull() && FullInf==1)
		{
			Item->appendSubItem ( 1, label2, false, NULL );
			font.setPixelSize(13);
		}
		else
			font.setPixelSize(15);
		
		setItemFont(ZListBox::region2, font, true);
		setItemFont(ZListBox::region2, font, false);
		
		this->insertItem ( Item,-1,true );
	}
	** END VARIANT 1*/
	
	/** VARIANT 2 */
	dir.setMatchAllDirs ( true );
	dir.setFilter ( QDir::Dirs | QDir::Hidden );
	if(!dir.isReadable())
	return;
	QStringList entries = dir.entryList();
	entries.sort();
	QStringList::ConstIterator it = entries.begin();
	sBasePath = dir.canonicalPath();
	while ( it != entries.end() ) {
	if ( (*it != ".") && (*it != ".."))
	{
		
		isBack = isBack && true;
		QFileInfo *fInfo = new QFileInfo (QString ( sPath + "/" + *it ));
		if(!fInfo->isSymLink())
			loadPic(pixmap, QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER).arg(FullInf));
			//pixmap.load(QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FOLDER).arg(FullInf));
		else
			loadPic(pixmap, QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER_LINK).arg(FullInf));
			//pixmap.load(QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_FOLDER_LINK).arg(FullInf));
		//if(fInfo->isSymLink())
		//	PmLink();
		date_time=fInfo->lastModified();
		
		ZListBoxItem* Item = new ZListBoxItem (this, QString (FListType));
		
		Item->setPixmap ( 0, pixmap );
		Item->appendSubItem ( 1, *it, false, NULL );
		if(!date_time.isNull() && FullInf==1)
		{
			Item->appendSubItem ( 1, fDate(date_time), false, NULL );
			font.setPixelSize(13);
		}
		else
		{
			font.setPixelSize(15);
		}
		
		setItemFont(ZListBox::region2, font, true);
		setItemFont(ZListBox::region2, font, false);
		
		insertItem ( Item, -1, true);
	}
	++it;
	}

	if (!OnlyDirs)
	{
	dir.setFilter ( QDir::Files | QDir::Drives | QDir::System | QDir::Hidden );

	entries = dir.entryList();
	entries.sort();
	it = entries.begin();
	while ( it != entries.end() )
	{
		if ( (*it != ".") && (*it != ".."))
		{
			isBack = isBack && true;
			
			QFileInfo *fInfo = new QFileInfo ( sPath + "/" + *it);
			
			
			if(fInfo->isFile())
			{
				if(!fInfo->isSymLink())
				{
					loadPic(pixmap, QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE).arg(FullInf));
					//pixmap.load(QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE).arg(FullInf));
					QString mime;
					mime=get_Mime(*it);
					for (int i=0;i<mime_nums;i++)
					{
						if(mime==mimes[i].type)
						{
							loadPic(pixmap, work_folder+QString("res/img/mime/%1/%2.png").arg(FullInf).arg(mimes[i].pm));
						}
					}
				}
				else
					loadPic(pixmap, QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE_LINK).arg(FullInf));
					//pixmap=QPixmap(QString(work_folder+"res/img/browser/%1/"+IDB_IMAGE_FILE_LINK).arg(FullInf));
				// mime detect pic
				
				size=fInfo->size();
				if(size < 1024)
				{
					fSize=QString("%1 b").arg(size);
				} else if(size < 1024 * 1024)
				{
					fSize=QString("%1 Kb").arg(floor(size/1024*100)/100);
				} else
				{
					fSize=QString("%1 Mb").arg(floor(size/1024/1024*100)/100);
				}
			}
			else
			{
				pixmap=QPixmap(QString(work_folder +"res/img/browser/%1/"+IDB_IMAGE_DEV).arg(FullInf));
			}
			//if(fInfo->isSymLink())
			//	PmLink();
			
			date_time=fInfo->lastModified();
			
			ZListBoxItem* Item = new ZListBoxItem ( this, FListType );
			Item->setPixmap ( 0, pixmap );
			Item->appendSubItem ( 1, *it, false, NULL );
			if(!date_time.isNull() && FullInf==1)
			{
				font.setPixelSize(13);
				if(fInfo->isFile() && fSize!="NULL")
					Item->appendSubItem ( 1, fDate(date_time)+"\t\t\t"+fSize, false, NULL );
				else
					Item->appendSubItem ( 1, fDate(date_time), false, NULL );
			}
			else
				font.setPixelSize(15);
			/**setItemFont(ZListBox::region2, font, true);
			setItemFont(ZListBox::region2, font, false);*/
			this->insertItem ( Item,-1,true );
		}
		++it;
	}
	}
	/** END VARIANT 2*/
	
	if((isBack) &&(sBasePath!="/") && (sBasePath!="//") && (sBasePath.length()>1) )
	{
		ZListBoxItem* Item = new ZListBoxItem ( this, "%I%M" );
		QPixmap pixmap=QPixmap ( work_folder + IDB_IMAGE_BACK );
		Item->setPixmap ( 0, pixmap );
		Item->appendSubItem ( 1, QString ( ".." ), false, NULL );
		if(multi_sel)
			Item->setEnabled(false);
		this->insertItem ( Item, 0,true );
		isBack = true;
	}
	setCurrentItem ( act_item );
}

void FileBrowserFtab::itemHighlighted ( int index )
{
  QString a = "";
  ZListBoxItem* listitem = this->item ( index );
  a = listitem->getSubItemText ( 1, 0, true );
  QString sPath = sBasePath + "/" + a;
  if ( QFileInfo ( sPath ).isFile() ) {
    sFileName = sPath;
  } else {
    sFileName = sPath;
  }
  ActItem=index;
}

// событие возникает при нажатии на центральную кнопку на элементе
void FileBrowserFtab::itemSelected ( int index )
{
	QString a = "";
	ZListBoxItem* listitem = this->item ( index );
	a = listitem->getSubItemText ( 1, 0, false );
	QString sPath = sBasePath + "/" + a;
	if(!multi_sel)
	{
		if ( QFileInfo ( sPath ).isDir() )
		{
			this->clear();
			setDir ( sPath, 0 );
			emit isFilePicked ( FALSE );
			emit picked ( sPath );
				
		}
		else
		{
			// загрузить файл и скрыть окно выбора файлов
			if ( QFileInfo ( sPath ).isFile() )
			{
				sFileName = sPath;
				emit isFilePicked ( TRUE );
			}
		}
	}
}

void FileBrowserFtab::loadPic(QPixmap &pic, QString way)
{
	if(!QPixmapCache::find(way, pic))
	{
		pic.load(way);
		QPixmapCache::insert(way, pic);
	}
}

QString FileBrowserFtab::getProgramDir ( const QString &AFileName )
{
  QString str = AFileName;
  int i = str.findRev ( "/" );
  str.remove ( i+1, str.length() - i );
  return str;
}

bool FileBrowserFtab::makedir(const QString &ASource, const QString &AName)
{
  if (ASource.isEmpty()) return false;
  if (AName.isEmpty()) return false;
  QDir dir;
  dir.setPath(ASource);
  return dir.mkdir(AName, false)  ;

}

QString FileBrowserFtab::get_Mime(QString file_name)
{
	int i = file_name.findRev (".");
	if (i==-1) return "fsman_execute";
	else return file_name.mid(i+1,file_name.length()-i).upper();
}
QString FileBrowserFtab::fDate(QDateTime date_time)
{
	QString dd;QString mm;
	QDate date=date_time.date();
	int d=date.day();
	int m=date.month();
	int y=date.year();
	if(d<10)	dd="0";	else dd="";
	if(m<10)	mm="0";	else mm="";
	return QString(dd+"%1/"+mm+"%2/%3").arg(d).arg(m).arg(y);	
}
void FileBrowserFtab::setFullInf()
	{
		/*if(FullInf==0)	FullInf=1;
		else			FullInf=0;*/
		FullInf=!FullInf;
		if(multi_sel)
		{
			if(FullInf)
				FListType="%I%M170%C";
			else
				FListType="%I%M186%C";
		}
	}
/*	
void FileBrowserFtab::PmLink()
	{
		QPixmap pm(work_folder+"res/img/browser/bg.png");
		p.begin(&pm, this);
		p.fillRect(0,0,32,32,Qt::white);
		p.drawPixmap(0, 0, pixmap);
		p.drawPixmap(0, 0, pm_link[FullInf]);
		p.end();
		pixmap=pm;
	}*/

void FileBrowserFtab::switchMultiSelect()
	{
		if(multi_sel)	{FListType="%I%M";multi_sel=false;}
		else
		{
			if(FullInf)
				FListType="%I%M170%C";
			else
				FListType="%I%M186%C";
			multi_sel=true;
		}
	}
	
QStringList FileBrowserFtab::getChkFileList()
	{
		QStringList mFileNameList;
		
		QString a;
		for (int i=0; i<(count()); ++i)
		{
			if(itemChecked(i))
			{
				ZListBoxItem* listitem = this->item(i);
				a = listitem->getSubItemText ( 1, 0, false );
				QString sPath = sBasePath + "/" + a;
				mFileNameList+=sPath;
			}
		}
		return mFileNameList;
	}

extern "C" int epeg_load_thumbnail(const char* srcFilename, int w, int h, FILE* tmpfp);

void FileBrowserFtab::LoadPreview()
	{
		if(pre_next)
		{
			pre_next=false;
			QString sPath, a, mime;
			int pm_h,pm_w;
			QPixmap pixmap;
			//QImage img;
			
			ZListBoxItem* listitem = this->item ( pre_i );
			a = listitem->getSubItemText ( 1, 0, false );
			sPath = sBasePath + "/" + a;
			mime=get_Mime(a);
			for (int i=0;i<mime_nums;i++)
			{
				if(mime==mimes[i].type && mimes[i].pm==2 && FullInf==1)
				{
					if(!QPixmapCache::find(sPath, pixmap))
					{
						i=mime_nums;
						bool jpg_thumbnail=false;
						if(mime=="JPG" || mime=="JPEG")
						{
							char *nailFileName="/tmp/.mystuff_thumbNail.jpg";
							FILE * fp=fopen(nailFileName,"wb");
							CHECK_PTR(fp);
							jpg_thumbnail=epeg_load_thumbnail(QFile::encodeName(sPath), thumbnail_size, thumbnail_size,fp);
							fclose(fp);
							if(jpg_thumbnail)
							{
								sPath=nailFileName;
								//this->item(pre_i)->appendSubItem ( 1, "jpg_thumbnail", false, NULL );
							}
						}
						pixmap=QPixmap(sPath);
						
						pm_w=pixmap.width();pm_h=pixmap.height();
						
						if((pm_w>thumbnail_size || pm_h>thumbnail_size) && !jpg_thumbnail)
						{
							int zoom_x=pm_w, zoom_y=pm_h;
							if(pm_w==pm_h)	{pm_w=thumbnail_size;pm_h=thumbnail_size;}
							else
							{
								if(pm_w>pm_h)	{pm_w=thumbnail_size;pm_h=zoom_y*pm_w/zoom_x;}
								if(pm_w<pm_h)	{pm_h=thumbnail_size;pm_w=zoom_x*pm_h/zoom_y;}
							}
							//img = pixmap.convertToImage();
							//img = img.smoothScale( pm_w, pm_h );
							//pixmap.convertFromImage( img );
							QWMatrix m;                         // transformation matrix
							m.scale(((double)pm_w)/zoom_x, ((double)pm_h)/zoom_y);// define scale factors
							pixmap=pixmap.xForm( m );           // create scaled pixmap
						}
						/*if(jpg_thumbnail)
						{*/
							int x=0, y=0;
							if(pm_w<pm_h)
								x=(thumbnail_size-pm_w)/2;
							else if(pm_w>pm_h)
								y=(thumbnail_size-pm_h)/2;
							else
								x=y=(thumbnail_size-pm_h)/2;
							
							QPixmap canvas(thumbnail_size,thumbnail_size);
							if(jpg_thumbnail)
								canvas.load(/*thumbnail_size,thumbnail_size*/work_folder +"res/img/browser/1/canvas.png");
							else
								canvas.fill(QColor(255,0,255));
							QPainter p;
							p.begin( &canvas, this );
							p.drawPixmap(x, y, pixmap);
							p.end();
							pixmap=canvas;
						//}
						QPixmapCache::insert(sPath, pixmap);
					}
					this->item(pre_i)->setPixmap ( 0, pixmap );
				}
			}
			pre_next=true;
		}
		if(pre_i>=count()-1) prev_timer->stop();
		else pre_i++;
	}

void FileBrowserFtab::keyPressEvent ( QKeyEvent* e )
{
  // get visble lines
  int vLines = -1;
  for (int y=0; y<(count()-1); ++y){
    if (itemVisible(y)) { ++vLines; }
  }
  
  switch ( e->key() ) 
  {
    
    case KEY_SIDE_UP:
    { // set top item
      int t = currentItem();
      if (t > (vLines - 1))   {
        this->setCurrentItem( t - vLines);
      } else { this->setCurrentItem( 0 ); }   
    break; }
    
    case KEY_SIDE_DOWN:
    { //set bottom item
      int t = currentItem();
      if (t < ( count() - vLines - 1))   {
        this->setBottomItem( t + vLines);
        this->setCurrentItem( t + vLines);
      } else { this->setCurrentItem( count() - 1 ); }   

    break; }
	
	case KEY_C:
	{ //go back
	  this->clear();
	  QString sPath = sBasePath + "/.." ;
	  setDir ( sPath, 0 );
	  emit isFilePicked ( FALSE );
	  emit picked ( sPath );
    break; }
    
    default:
      ZListBox::keyPressEvent ( e );
  }       
}
