#include <ZConfig.h>

QString LANG_OPEN_WITH;
QString LANG_DELETE;
QString LANG_COPY_MENU;
QString LANG_RENAME;
QString LANG_MKDIR;
QString LANG_BOOKMARK;
QString LANG_ADD_BOOKMARK;
QString LANG_BT;
QString LANG_PROPERTIES;

QString LANG_COPY;
QString LANG_MOVE;
QString LANG_PASTE;
QString LANG_PASTE_AS;

QString LANG_OPTIONS;
QString LANG_CANCEL;
QString LANG_YES;
QString LANG_NO;

QString LANG_TYPE;
QString LANG_NAME;
QString LANG_PATH;
QString LANG_FOLDER;
QString LANG_FILE;
QString LANG_DIRS;
QString LANG_FILES;
QString LANG_SYMLINK;
QString LANG_UNK;
QString LANG_SIZE;
QString LANG_OWNER;
QString LANG_PERM;

QString LANG_EXIT;
QString LANG_ERROR;
QString LANG_WARNING;
QString LANG_COPYING;
QString LANG_MOVING;
QString LANG_PLEASE_WAIT;

QString LANG_NOT_EXEC;
QString LANG_DELETE_DIR;
QString LANG_DELETE_FILE;
QString LANG_UNABLE_DELETE;
QString LANG_MOVE_SURE;
QString LANG_COPY_EXISTS;
QString LANG_DON_TRY_COPY;
QString LANG_DON_TRY_MOVE;
QString LANG_ERRORMOVE_HALF;
QString LANG_RENAME_ERROR;
QString LANG_RENAME_EXISTS;
QString LANG_ENTER_DIRNAME;
QString LANG_RENAME_DIREXISTS;

QString LANG_EXIT_SURE;
extern QString work_folder;
extern QString lang;
	
void FM::LoadLang()
	{
		QString lang_path=work_folder+"/lang/"+lang+".lang";

		qDebug("--- read lang file: "+lang_path);
		ZConfig fm_lang(lang_path, true);
		
		int c_ver=102;
		int ver=atoi(fm_lang.readEntry(QString("Language"), QString("VER"), ""));
		if(ver<c_ver)
			qDebug(QString("WARNING: Version of lang file is %1 - please update it to %2").arg(ver).arg(c_ver));

		LANG_OPEN_WITH			=fm_lang.readEntry(QString("Language"), QString("OPEN_WITH"), "Open with..");
		LANG_DELETE				=fm_lang.readEntry(QString("Language"), QString("DELETE"), "Delete");
		LANG_COPY_MENU			=fm_lang.readEntry(QString("Language"), QString("COPY_MENU"), "Copy menu");
		LANG_RENAME				=fm_lang.readEntry(QString("Language"), QString("RENAME"), "Rename");
		LANG_MKDIR				=fm_lang.readEntry(QString("Language"), QString("MKDIR"), "Make Dir");
		LANG_BOOKMARK			=fm_lang.readEntry(QString("Language"), QString("BOOKMARK"), "Bookmarks");
		LANG_ADD_BOOKMARK		=fm_lang.readEntry(QString("Language"), QString("ADD_BOOKMARK"), "Add Bookmark");
		LANG_BT					=fm_lang.readEntry(QString("Language"), QString("BLUETOOTH"), "Send by Bluetooth");
		LANG_PROPERTIES			=fm_lang.readEntry(QString("Language"), QString("PROPERTIES"), "Properties");

		LANG_COPY				=fm_lang.readEntry(QString("Language"), QString("COPY"), "Copy");
		LANG_MOVE				=fm_lang.readEntry(QString("Language"), QString("MOVE"), "Move");
		LANG_PASTE				=fm_lang.readEntry(QString("Language"), QString("PASTE"), "Paste");
		LANG_PASTE_AS			=fm_lang.readEntry(QString("Language"), QString("PASTE_AS"), "Paste as..");
		
		LANG_OPTIONS			=fm_lang.readEntry(QString("Language"), QString("OPTIONS"), "Options");
		LANG_CANCEL				=fm_lang.readEntry(QString("Language"), QString("CANCEL"), "Cancel");
		LANG_YES				=fm_lang.readEntry(QString("Language"), QString("YES"), "Yes");
		LANG_NO					=fm_lang.readEntry(QString("Language"), QString("NO"), "No");

		LANG_TYPE				=fm_lang.readEntry(QString("Language"), QString("TYPE"), "Type");
		LANG_NAME				=fm_lang.readEntry(QString("Language"), QString("NAME"), "Name");
		LANG_PATH				=fm_lang.readEntry(QString("Language"), QString("PATH"), "Path");
		LANG_FOLDER				=fm_lang.readEntry(QString("Language"), QString("FOLDER"), "Dir");
		LANG_FILE				=fm_lang.readEntry(QString("Language"), QString("FILE"), "File");
		LANG_DIRS				=fm_lang.readEntry(QString("Language"), QString("DIRS"), "Dirs");
		LANG_FILES				=fm_lang.readEntry(QString("Language"), QString("FILES"), "Files");
		LANG_SYMLINK 			=fm_lang.readEntry(QString("Language"), QString("SYMLINK"), "Symlink");
		LANG_UNK 				=fm_lang.readEntry(QString("Language"), QString("UNK"), "Unknown");
		LANG_SIZE 				=fm_lang.readEntry(QString("Language"), QString("SIZE"), "Size");
		LANG_OWNER 				=fm_lang.readEntry(QString("Language"), QString("OWNER"), "Owner");
		LANG_PERM 				=fm_lang.readEntry(QString("Language"), QString("PERM"), "Permissions");

		LANG_EXIT   			=fm_lang.readEntry(QString("Language"), QString("EXIT"), "Exit");
		LANG_ERROR				=fm_lang.readEntry(QString("Language"), QString("ERROR"), "Error");
		LANG_WARNING			=fm_lang.readEntry(QString("Language"), QString("WARNING"), "Warning");
		LANG_COPYING			=fm_lang.readEntry(QString("Language"), QString("COPYING"), "Copying");
		LANG_MOVING				=fm_lang.readEntry(QString("Language"), QString("MOVING"), "Moving");
		LANG_PLEASE_WAIT		=fm_lang.readEntry(QString("Language"), QString("PLEASE_WAIT"), "Please wait..");

		LANG_NOT_EXEC 			=fm_lang.readEntry(QString("Language"), QString("NOT_EXEC"), "File is not executable..or I'v done something wrong..");
		LANG_DELETE_DIR			=fm_lang.readEntry(QString("Language"), QString("DELETE_DIR"), "Delete dir?");
		LANG_DELETE_FILE		=fm_lang.readEntry(QString("Language"), QString("DELETE_FILE"), "Delete file?");
		LANG_UNABLE_DELETE 		=fm_lang.readEntry(QString("Language"), QString("UNABLE_DELETE"), "Unable to delete..");
		LANG_MOVE_SURE			=fm_lang.readEntry(QString("Language"), QString("MOVE_SURE"), "Move for sure?");
		LANG_COPY_EXISTS 		=fm_lang.readEntry(QString("Language"), QString("COPY_EXISTS"), "already exists. Change old file?");
		LANG_DON_TRY_COPY 		=fm_lang.readEntry(QString("Language"), QString("DON_TRY_COPY"), "Belive me you don't want to copy a dir in the same dir recursively, couse I'm using recursive copy..");
		LANG_DON_TRY_MOVE 		=fm_lang.readEntry(QString("Language"), QString("DON_TRY_MOVE"), "Moving a dir in the same dir: is like deleting it. Don't waste time..");
		LANG_ERRORMOVE_HALF  	=fm_lang.readEntry(QString("Language"), QString("ERRORMOVE_HALF"), "Copyed but not moved..");
		LANG_RENAME_ERROR 		=fm_lang.readEntry(QString("Language"), QString("RENAME_ERROR"), "Can not rename..");
		LANG_RENAME_EXISTS 		=fm_lang.readEntry(QString("Language"), QString("RENAME_EXISTS"), "This name already exists.");
		LANG_ENTER_DIRNAME		=fm_lang.readEntry(QString("Language"), QString("ENTER_DIRNAME"), "Enter Dirname:");
		LANG_RENAME_DIREXISTS	=fm_lang.readEntry(QString("Language"), QString("RENAME_DIREXIST"), "A dir with that name already exists..");
		
		LANG_EXIT_SURE			=fm_lang.readEntry(QString("Language"), QString("EXIT_SURE"), "Are you sure want exit FsMan?");
	}
