/* 
 * File:   fm.cpp
 * Autor: Strelok Vlad Kolerts
 *
 * Created on Martch 16, 2009, 2:19 AM
 */

#include "fm.h"
#include "util.h"

extern util *u;
extern QDaemonApp* a;

extern QString path_tab1, path_tab2;
extern bool full_inf, full_scr;
extern int header_type;

#include <vector>
extern std::vector<plugin_struct> plugins;
extern int plug_nums;
extern std::vector<mime_struct> mimes;
extern int mime_nums;

#include "LangRead.h"

//#include <unistd.h>//execv
//#include <sys/types.h>//execv
#include <stdio.h>
#include <sys/vfs.h>

///#include <ZIconView.h>

////////////////////
#include "tools/kWidget.h"
kWidget* textView;
kWidget* processView;

FM::FM() : ZKbMainWidget((ZHeader::HEADER_TYPE)3, NULL, "ZMainWidget", 0)//	TIME_TYPE,	TINY_TYPE,	SMALL_TYPE,	FULL_TYPE
{
	QString d_about;
	d_about="\n--------------------------\n";
	d_about+="--------FsMan 1.6---------\n";
	d_about+="-File manager for ROKR E2-\n";
	d_about+="-------Written by --------\n";
	d_about+="-(c) Strelok Vlad Kolerts-\n";
	d_about+="--------10/06/2010--------\n";
	d_about+="------kolerts@ukr.net-----\n";
	d_about+="------http://e2.at.ua-----\n";
	d_about+="--------------------------\n";
	qDebug(d_about);
	
	if(!ypoCkhc())
	{
		qDebug("> Fuck you man! <");
		a->quit();
	}
	
	QFont font("KolertsFont",14,25,false);
	setFont(font);
	
	processView = new kWidget();
	processView->setFont(font);
	/*ProcessScreen = new ScrProcess(work_folder);
	ProcessScreen->setFont(font);
	ProcessScreen->start("FsMan starting", NULL, 0, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);*/
	processView->showProcess("FsMan starting", "", 0, "Please wait..", Qt::AlignHCenter, IDB_OPEN_WITH, false);
	a->processEvents();

	push_but=0;
	push_green=false;
	resize(240,320);
	a->installEventFilter(this);
    setMainWidgetTitle("FsMan");
    tabrn = 1;
    ProgDir = u->getProgramDir();
    QVBoxLayout* layout = getVBoxLayout();
    tabWidget = new ZNavTabWidget(ZNavTabWidget::SEPARATE, false, false, this);
	
	LoadLang();
	qDebug("--- read lang ok");
	MimeConfig();
	qDebug("--- read mimes ok");
	PluginConfig();
	qDebug("--- read plugins ok");
	BookmarkConfig();
	qDebug("--- read bookmarks ok");

	setHeaderType((ZHeader::HEADER_TYPE)header_type);
	if(work_folder==NULL)	work_folder=ProgDir;
	fullScreenModeChanged(full_scr);
	
	textView = new kWidget();
	textView->setFont(font);
	
	textInput = new TextInput(work_folder);
	textInput->setFont(font);
	textInput->lCopy="\t\t\t"+LANG_COPY;
	textInput->lPaste="\t\t\t"+LANG_PASTE;
	textInput->lYes=LANG_YES;
	textInput->lNo=LANG_NO;
	textInput->Init();
	
	///copyTool = new CopyTool();
    QPixmap pm;
    ftab = new FileBrowserFtab(full_inf, "%I%M", this, 0);
    ftab->setDir(path_tab1,0);
	//ftab->setFont(font);

    stab = new FileBrowserFtab(full_inf, "%I%M", this, 0);
    stab->setDir(path_tab2,0);
	//stab->setFont(font);

    pm.load(work_folder+IDB_IMAGE_TAB1);
    tabWidget->addTab(ftab, pm, "");
    pm.load(work_folder+IDB_IMAGE_TAB2);
    tabWidget->addTab(stab, pm, "");
    ftab->setFocus();
	
	drawAbout();
	
    aboutWidget = new QWidget(this);
	aboutWidget->setBackgroundPixmap( about_widget );
	
    pm.load(work_folder+IDB_IMAGE_ABOUT);
    tabWidget->addTab(aboutWidget, pm, "");

    layout->addWidget(tabWidget);
	/**ZIconView* icon_view = new ZIconView(this, "", 0, 0, 0, (ZSkinService::WidgetClsID)4);
	icon_view->setLayout(3, 4, false);
	int counter=0;
	for(int i=0;i<16;i++)
	{
		ZIconViewItem* item = new ZIconViewItem((ZIconView*)icon_view);
		item->setText("test"+QString::number(icon_view->iconAreaSize().width()));
		item->setPixmap(pm);
		item->setAlign(ZIconViewItem::ALIGN_TEXT,Qt::AlignHCenter);
        item->setReservedData(counter++);
	}
	layout->addWidget(icon_view);
	icon_view->setFocus();*/
	createSoftKeys();
	createSoftKeysStab();
    setSoftKey(softKey);
    connect(tabWidget, SIGNAL(currentChanged(QWidget*)), this, SLOT(slotCurrentChanged(QWidget*)));
	
	cop = new QCopChannel("FsMan", this);
	connect(cop, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&)));

	connect(stab, SIGNAL(isFilePicked(bool)), this, SLOT(slot_ClickFile(bool)));
	connect(ftab, SIGNAL(isFilePicked(bool)), this, SLOT(slot_ClickFile(bool)));
	
	connect(a, SIGNAL(signalRaise()), this, SLOT(show()));

	processView->stop(10);
}

FM::~FM()
{
}

void FM::slotCurrentChanged(QWidget* AWidget)
	{
		int i = tabWidget->currentPageIndex();
		
		switch (i) {
			case 0:
			{
				softKey->setOptMenu(ZSoftKey::LEFT, menu);
				softKey->setText(ZSoftKey::LEFT, LANG_OPTIONS, (ZSoftKey::TEXT_PRIORITY) 0);
				tabrn = 1;
				break;
			}
			case 1:
			{
				softKey->setOptMenu(ZSoftKey::LEFT, menu);
				softKey->setText(ZSoftKey::LEFT, LANG_OPTIONS, (ZSoftKey::TEXT_PRIORITY) 0);
				tabrn = 2;
				break;
			}
			case 2:
			{
				AWidget -> setFocus();
				softKey->setOptMenu(ZSoftKey::LEFT, NULL);
				softKey->setText(ZSoftKey::LEFT, "", (ZSoftKey::TEXT_PRIORITY) 0);
				tabrn = 3;
				break;
			}
		}
	}

///////////////////////////////////////////////////////////////////////////////////////

QString FM::getFilePath(const QString &AFileName)
{
	QString str = AFileName;
	int i = str.findRev("/");
	str.remove(i + 1, str.length() - i);
	return str;
}

QString FM::getFileName(const QString &AFileName)
{
	QString str = AFileName;
	int i = str.findRev("/");
	str.remove(0, i);
	if (str.left(1) = "/") str.remove(0, 1);
	return str;
}

QString FM::getMime(QString file_name)
{
	int i = file_name.findRev (".");
	if (i==-1) return "unknown";
	else return file_name.mid(i+1,file_name.length()-i).upper();
}

QString FM::ExecFormat(QString file_name)
{
	return QString("\"%1\"").arg(file_name.utf8());
}

QString FM::getActiveFileName()
{
	QString fName;
	if (tabrn == 1)
		fName = ftab -> getFileName();
	else if (tabrn == 2)
		fName = stab -> getFileName();

	return fName;
}

QStringList FM::getActiveFileNames()
{
	QStringList fNameList;
	if (tabrn == 1)
	{
		fNameList=ftab->getChkFileList();
		ftab->switchMultiSelect();
		ftab->setDir(ftab->getFilePath(),ftab->getActItem());
	}
	else if (tabrn == 2)
	{
		fNameList=stab->getChkFileList();
		stab->switchMultiSelect();
		stab->setDir(stab->getFilePath(),stab->getActItem());
	}

	return fNameList;
}

bool FM::getActiveMultiStat()
{
	bool stat=false;
	if (tabrn == 1)
		stat=ftab->MultiSel();
	else if (tabrn == 2)
		stat=stab->MultiSel();
	
	return stat;
}

///////////////////////////////////////////////////////////////////////////////////////

void FM::createSoftKeys()
	{
		QRect rect;
		softKey = new ZSoftKey(NULL, this, this);
		//menu = new ZOptionsMenu(rect, softKey, NULL, 0);
		
		softKey->setText(ZSoftKey::LEFT, LANG_OPTIONS, (ZSoftKey::TEXT_PRIORITY) 0);
		//softKey->setText(ZSoftKey::RIGHT, LANG_EXIT, (ZSoftKey::TEXT_PRIORITY) 0);
		//softKey->setClickedSlot(ZSoftKey::RIGHT, a, SLOT(quit()));
	}

void FM::createSoftKeysFtab()
	{
		QString temp_line;
		QRect rect;
		
		QPixmap* pm = new QPixmap();
		menu = new ZOptionsMenu(rect, softKey, NULL, 0);
		open_with_menu = new ZOptionsMenu(rect, NULL, NULL, 0);
		pravka_menu = new ZOptionsMenu(rect, NULL, NULL, 0);
		bookmark_menu = new ZOptionsMenu(rect, NULL, NULL, 0);
		softKey->setOptMenu(ZSoftKey::LEFT, menu);

		QFile plugin_file(work_folder+"/fm_plugins.cfg");
			
		for(int i=0; i<plug_nums; i++)
		{
			QString plug_name=plugins[i].name;
			pm->load(work_folder+"/res/img/unk_plugin.png");
			if (plugins[i].type==0)
			{
				if(searchPlugin(plugins[i].name))
					pm->load(work_folder+"/plugins/"+plugins[i].name+"/icon.png");
			}
			
			
			if (plugins[i].type==1) 
			{
				pm->load(QString(work_folder+"/plugins/full_path/%1/icon.png").arg(plugins[i].id));
				QFile file_tmp(QString(work_folder+"/plugins/full_path/%1/desktop.ini").arg(plugins[i].id));
				if( file_tmp.open(IO_ReadOnly) )	
				{							
					QTextStream stream( &file_tmp );	
					plug_name=stream.readLine();
					file_tmp.close();
				}
				else plug_name="Unknown";
			}						
			if (plugins[i].type==0 or plugins[i].type==1)
			{
				open_with_menu->insertItem("\t\t\t"+plug_name, NULL, pm, true, i, i);
				open_with_menu->connectItem(i, this, SLOT(slot_OpenWith()));
			}
		}
		
		int i=0;
		while(i<(int)bm_name.count())
		{
			bookmark_menu->insertItem(bm_name[i], NULL, NULL, true, i, i);
			bookmark_menu->connectItem(i, this, SLOT(slot_BookMark()));
			i++;
		}
		pm->load(work_folder+IDB_IMAGE_ADD);
		bookmark_menu->insertItem("\t\t\t"+LANG_ADD_BOOKMARK, NULL, pm, true, i, i);
		bookmark_menu->connectItem(i, this, SLOT(slot_AddBookMark()));
		
		pm->load(work_folder+IDB_IMAGE_COPY);
		pravka_menu->insertItem("\t\t\t"+LANG_COPY, NULL, pm, true, 1, 1);
		pm->load(work_folder+IDB_IMAGE_MOVE);
		pravka_menu->insertItem("\t\t\t"+LANG_MOVE, NULL, pm, true, 2, 2);
		pm->load(work_folder+IDB_IMAGE_PASTE);
		pravka_menu->insertItem("\t\t\t"+LANG_PASTE, NULL, pm, false, 3, 3);
		pm->load(work_folder+IDB_IMAGE_PASTE);
		pravka_menu->insertItem("\t\t\t"+LANG_PASTE_AS, NULL, pm, false, 4, 4);
		
		pravka_menu->connectItem(1, this, SLOT(slot_Copy()));
		pravka_menu->connectItem(2, this, SLOT(slot_Move()));

		pm->load(work_folder+IDB_OPEN_WITH);
		menu->insertItem("\t\t\t"+LANG_OPEN_WITH, open_with_menu, pm, true, 1, 1);
		pm->load(work_folder+IDB_IMAGE_DELETE);
		menu->insertItem("\t\t\t"+LANG_DELETE, NULL, pm, true, 2, 2);
		pm->load(work_folder+IDB_IMAGE_COPY);
		menu->insertItem("\t\t\t"+LANG_COPY_MENU, pravka_menu, pm, true, 3, 3);
		pm->load(work_folder+IDB_IMAGE_RENAME);
		menu->insertItem("\t\t\t"+LANG_RENAME, NULL, pm, true, 4, 4);
		pm->load(work_folder+IDB_IMAGE_MKDIR);
		menu->insertItem("\t\t\t"+LANG_MKDIR, NULL, pm, true, 5, 5);
		pm->load(work_folder+IDB_IMAGE_BOOKMARK);
		menu->insertItem("\t\t\t"+LANG_BOOKMARK, bookmark_menu, pm, true, 6, 6);
		pm->load(work_folder+IDB_IMAGE_BT);
		menu->insertItem("\t\t\t"+LANG_BT, NULL, pm, true, 7, 7);
		pm->load(work_folder+IDB_IMAGE_PROPS);
		menu->insertItem("\t\t\t"+LANG_PROPERTIES, NULL, pm, true, 8, 8);

		/*menu->insertSeparator(1, 1);*/
		menu->connectItem(2, this, SLOT(slot_Delete()));
		menu->connectItem(4, this, SLOT(slot_Rename()));
		menu->connectItem(5, this, SLOT(slot_MkDir()));
		//menu->connectItem(8, this, SLOT(slot_BookMark()));
		menu->connectItem(7, this, SLOT(slot_SendBt()));
		menu->connectItem(8, this, SLOT(slot_Properties()));

	}

void FM::createSoftKeysStab() {
    createSoftKeysFtab();
}

void FM::slot_Delete()
	{
		QStringList fNameList;
		
		if(getActiveMultiStat())
			{
				fNameList=getActiveFileNames();
			}
		else
			{
				fNameList[0]=getActiveFileName();
			}
		
		for(int i=0;i<=(int)fNameList.count();i++)
		{
			if (fNameList[i].isEmpty()) return;
			QFileInfo* fInfo = new QFileInfo(fNameList[i]);
			bool isDelete = false;
			if (fInfo->isDir())
			{
				if (textView->showText(LANG_DELETE_DIR, fNameList[i], Qt::AlignHCenter, IDB_IMAGE_DELETE, 2))
				{
					isDelete = true;
				}
			}
			else if (fInfo->isFile())
			{
				if (textView->showText(LANG_DELETE_FILE, fNameList[i], Qt::AlignHCenter, IDB_IMAGE_DELETE,2))
				{
					isDelete = true;
				}
			}
			if (isDelete) {
				if (!DeleteFile(fNameList[i]))
				{
					textView->showText(LANG_ERROR, LANG_UNABLE_DELETE, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				}
				else
				{
					if (tabrn == 1)
					{
						ftab->setDir(ftab -> getFilePath(),ftab->getActItem());
					}
					else if (tabrn == 2)
					{
						stab->setDir(stab -> getFilePath(),stab->getActItem());
					}
				}
			}
		}
	}

bool FM::DeleteFile(QString AFileName)
	{
		QFileInfo* fInfo = new QFileInfo(AFileName);
		if (fInfo->isFile())
		{
			QFile f;
			if (f.exists(AFileName))
			{
				f.remove(AFileName);
				if (f.exists(AFileName))	textView->showText(LANG_ERROR, LANG_UNABLE_DELETE, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				return true;
			}
			else return false;
		}
		else
		{
			QDir d;
			if (d.exists(AFileName, true))
			{
				!system("rm -f -r " + ExecFormat(AFileName));
				if (d.exists(AFileName, true))	textView->showText(LANG_ERROR, LANG_UNABLE_DELETE, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				return true;
			}
			else return false;
		}
	}
	
void FM::copy(QString from, QString to)
{
	if(!push_green)
	{
		textView->showText(LANG_COPYING, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
		a->processEvents();
		system(QString("cp -R %1 %2").arg(ExecFormat(from)).arg(ExecFormat(to)));
		//qApp->processEvents();
		textView->init();
	}
	else
	{
		bool remove=0;
		to+="/";

		struct statfs stat;
		unsigned long freeSize = 0;  
		int TargetSize = 0;
		
		QString name = getFileName(from);

		QString destName = to;
		//destName.prepend(name);


		// check free space
		/*if(statfs(destName, &stat)<0)
		{
			qDebug("IDS_ERROR_GET_FREE_SPACE");
			textView->showText(LANG_COPYING, "IDS_ERROR_GET_FREE_SPACE"+QString::number(statfs(destName, &stat)), Qt::AlignHCenter, IDB_IMAGE_COPY, 1);
		}
		else
		{*/
			destName.append("/" + name);

			freeSize = stat.f_bsize*stat.f_bfree;
			///qDebug(QString("FreeSize: %1").arg(freeSize));
			QFileInfo* fInfoSource = new QFileInfo ( from );
			if(fInfoSource->isDir())
			{
				// make ASource dir in DestDir
				QDir SourceDD;
				if(!SourceDD.exists(destName))
					SourceDD.mkdir(destName);

				TargetSize = GetDirSize ( from );
				///int cntFiles = file_num;
				if((TargetSize >= 0))//(freeSize > TargetSize) && 
				{
					QStringList fullFiles;
					QStringList::Iterator it;
					fullFiles = GetFilesInFolder( from );

					if (fullFiles.count() > 0)
					{
						it = fullFiles.begin();

						while(it!=fullFiles.end())
						{
							//QString b = getFileName(*it);
							QString b = QString(*it).remove(0,getFilePath(from).length());
							QDir dd;
							QString ss;
							ss = to + b;
							int ii = ss.findRev ( "/" );
							ss.remove ( ii+1, ss.length() - ii );
							if ( ! dd.exists(ss))
								dd.mkdir(ss);
							
							CopyFile(*it, to + b);
							++it;
						}
					}
					else
					{
						textView->showText(LANG_COPYING, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
						a->processEvents();
						system(QString("cp -R %1 %2").arg(ExecFormat(from)).arg(ExecFormat(to)));
						textView->init();
					}
					if(remove)
						DeleteFile ( from );
				}
			}
			else
			{
				if(fInfoSource->isFile())
				{
					TargetSize = fInfoSource->size(); 
				}
			}

			if((TargetSize>=0)) //(freeSize>TargetSize) && 
			{
				CopyFile(from, to + "/" + name);
				if(remove)
				{
					QFile f;
					f.remove ( from );
				}
			}
			else
			{
				textView->showText(LANG_COPYING, "IDS_ERROR_NON_FREE_SPACE", Qt::AlignHCenter, IDB_IMAGE_COPY, 1);
			}
		//}
	}
}
	
bool FM::CopyFile(QString ASourceName, QString ADestName)
{
	QFileInfo* fInfo = new QFileInfo ( ASourceName );
	if(fInfo->isFile())
	{ //copy file
		long size = fInfo->size();
		long size2 = fInfo->size();
		QString _size;
		QString _size2=countSize(size2);

		textView->showText(LANG_COPYING, QString("%1\nto\n%2").arg(ASourceName).arg(ADestName)+QString("<hr>Completed: 0\% (0 b/%3)").arg(_size2), Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
		
		QFile fDest ( ADestName );
		QFile fSource ( ASourceName );
		int blockSize = 512*1024;
		unsigned long i = 0;
		double u = 0;
		char* p=NULL;
		a->processEvents();
		
		if(fSource.open(IO_ReadOnly))
		{
			p=new char[blockSize];
			fDest.open ( IO_WriteOnly );
			do
			{
				size = fSource.readBlock ( p, blockSize );
				if(size==-1 || fDest.writeBlock(p, size) == -1)
				{
					return FALSE;
				}
				u = 100*(double)i/size2;
				_size=countSize(i);
				///zm->setProgress((int)u);
				///ProcessScreen->start(LANG_COPYING, QString("%1<br/>to<br/>%2").arg(ASourceName).arg(ADestName), 1, QString("Completed: %1\% (%2/%3)").arg((int)u).arg(Size).arg(Size2), 1, IDB_IMAGE_COPY, false);
				textView->showText(LANG_COPYING, QString("%1\nto\n%2").arg(ASourceName).arg(ADestName)+QString("<hr>Completed: %1\% (%2/%3)").arg((int)u).arg(_size).arg(_size2), Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
				///zp->setInstructText(QString("Completed: %1\%").arg((int)u*10));
				a->processEvents();
				i += size;
			}
			while (size == blockSize);
				delete[] p;
			qApp->processEvents();
		}
	}
	///ProcessScreen->stop();
	///delete zp;
	textView->init();
	
	return TRUE;      
}

void FM::slot_Copy()
	{
		QRect rect;
		pravka_menu->disconnectItem(3, this, SLOT(slot_MoveTo()));
		pravka_menu->connectItem(3, this, SLOT(slot_CopyTo()));
		pravka_menu->setItemEnabled(3, true);
		
		QStringList fNameList;
		
		if(getActiveMultiStat())
			{
				fNameList=getActiveFileNames();
			}
		else
			{
				fNameList[0]=getActiveFileName();
			}
		
		st=fNameList;
	}

void FM::slot_CopyTo()
	{
		QString path_to;
		if (tabrn == 1)
		{
			createSoftKeysFtab();
			path_to=ftab -> getFilePath();
		}
		if (tabrn == 2)
		{
			createSoftKeysStab();
			path_to=stab -> getFilePath();
		}
		
		pravka_menu->setItemEnabled(3, false);
		softKey->setOptMenu(ZSoftKey::LEFT, menu);
		
		///
		
		for(int i=0;i<=(int)st.count();i++)
		{
			if(st[i]!="")
				ChkCopy(st[i], path_to);
		}
		///copyTool->go(st, path_to, 0);
	}

void FM::slot_Move()
	{
		QRect rect;
		pravka_menu->disconnectItem(3, this, SLOT(slot_CopyTo()));
		pravka_menu->connectItem(3, this, SLOT(slot_MoveTo()));
		pravka_menu->setItemEnabled(3, true);
		
		QStringList fNameList;
		
		if(getActiveMultiStat())
			{
				fNameList=getActiveFileNames();
			}
		else
			{
				fNameList[0]=getActiveFileName();
			}
		
		st=fNameList;
	}

void FM::slot_MoveTo()
	{
		QString path_to;
		if (tabrn == 1)
		{
			createSoftKeysFtab();
			path_to=ftab -> getFilePath();
		}
		if (tabrn == 2)
		{
			createSoftKeysStab();
			path_to=stab -> getFilePath();
		}
		
		pravka_menu->setItemEnabled(3, false);
		softKey->setOptMenu(ZSoftKey::LEFT, menu);
		
		///
		
		for(int i=0;i<=(int)st.count();i++)
		{
			if(st[i]!="")
				ChkMove(st[i], path_to);
		}
		///copyTool->go(st, path_to, 1);
	}
void FM::ChkCopy(QString from, QString to)
	{
		QFile qfto(to + "/" + getFileName(from));
		
		if (from != to)
		{
			if (qfto.exists()) 
			{
				if(textView->showText(LANG_WARNING, "\""+getFileName(from)+"\" "+LANG_COPY_EXISTS, Qt::AlignHCenter, IDB_IMAGE_WARNING, 2))
				{
					DeleteFile(to+"/"+getFileName(from));
					if (!qfto.exists())
					{
						copy(from, to);
					}
					else textView->showText(LANG_ERROR, LANG_DON_TRY_COPY, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				}
			}
			else
			{
				copy(from, to);
			}
		}
		else	textView->showText(LANG_ERROR, LANG_DON_TRY_COPY, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
		
		ftab -> setDir(ftab -> getFilePath(),ftab->getActItem());
		stab -> setDir(stab -> getFilePath(),stab->getActItem());
	}

void FM::ChkMove(QString from, QString to)
	{
		QFile qfto(to + "/" + getFileName(from));
		QFile qf(from);
		if (from != to)
		{
			if (textView->showText(LANG_MOVE_SURE, getFileName(from) + " to " + to, Qt::AlignHCenter, IDB_IMAGE_WARNING, 2))
			{
				if (qfto.exists()) 
				{
					if(textView->showText(LANG_WARNING, "\""+getFileName(from)+"\" "+LANG_COPY_EXISTS, Qt::AlignHCenter, IDB_IMAGE_WARNING, 2))
					{
						DeleteFile(to+"/"+getFileName(from));
						if (!qfto.exists())
						{
							//copy(from, to);
							a->processEvents();
							if (u -> fExist(QString("%1/bin/sys_gui").arg(ProgDir)))
							{
								system(ProgDir+QString("bin/sys_gui mv %1 %2 %3 %4 %5").arg(ExecFormat(from)).arg(ExecFormat(to)).arg(ExecFormat("Moving")).arg(ExecFormat("Please wait..")).arg(ExecFormat(work_folder+IDB_IMAGE_COPY)));
							}
							else	
							{
								textView->showText(LANG_MOVING, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
								a->processEvents();
								system(QString("mv %1 %2").arg(ExecFormat(from)).arg(ExecFormat(to)));
							}
							//DeleteFile(from);
						}
						else textView->showText(LANG_ERROR, LANG_DON_TRY_MOVE, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
					}
				}
				else
				{
					//copy(from, to);
					a->processEvents();
					if (u->fExist(QString("%1/bin/sys_gui").arg(ProgDir)))
					{
						system(ProgDir+QString("bin/sys_gui mv %1 %2 %3 %4 %5").arg(ExecFormat(from)).arg(ExecFormat(to)).arg(ExecFormat("Moving")).arg(ExecFormat("Please wait..")).arg(ExecFormat(work_folder+IDB_IMAGE_COPY)));
					}
					else	
					{
						textView->showText(LANG_MOVING, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_IMAGE_COPY, 0);
						a->processEvents();
						system(QString("mv %1 %2").arg(ExecFormat(from)).arg(ExecFormat(to)));
					}
					//DeleteFile(from);
				}
			}
			a->processEvents();
			textView->init();
		}
		else	textView->showText(LANG_ERROR, LANG_DON_TRY_MOVE, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
		ftab -> setDir(ftab -> getFilePath(),ftab->getActItem());
		stab -> setDir(stab -> getFilePath(),stab->getActItem());
	}

void FM::slot_Rename()
	{
		//repeat:
		QString FullName;
		QString tmpName;
		if(tabrn == 1)
		{
			FullName = ftab->getFileName();
			tmpName = ftab->getFileName();
		}
		else if(tabrn == 2)
		{
			FullName = stab->getFileName();
			tmpName = stab->getFileName();
		}
		if (FullName.isEmpty()) return;
	
		QString fName = getFileName(FullName);
		QString fPath = getFilePath(FullName);
		
		textInput->LineText=fName;
		if(textInput->showText(LANG_RENAME, LANG_RENAME+" \""+fName+"\":", IDB_IMAGE_RENAME))
		{
			fName = textInput->LineText;
			FullName = fPath + fName;
			QDir d;
			if(!d.exists(FullName))
			{
				if(d.rename(tmpName, FullName, true))
				{
					if(tabrn == 1)
					{
						ftab->setDir(fPath,ftab->getActItem());
						stab->setDir(stab->getFilePath(),stab->getActItem());
					}
					else if(tabrn == 2)
					{
						stab->setDir(fPath,stab->getActItem());
						ftab->setDir(ftab->getFilePath(),ftab->getActItem());
					}
				}
				else
					textView->showText(LANG_ERROR, LANG_RENAME_ERROR, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
			}
			else
				textView->showText(LANG_ERROR, LANG_RENAME_EXISTS, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
		}
	}

void FM::slot_MkDir()
	{
		QString pa;
		if(tabrn == 1)
			pa = ftab -> getFilePath();
		else if(tabrn == 2)
			pa = stab -> getFilePath();
		QString dn;
		textInput->LineText="";
		if(textInput->showText(LANG_MKDIR, LANG_ENTER_DIRNAME, IDB_IMAGE_MKDIR))
		{
			dn = textInput->LineText;
			if(dn != "")
			{
				if (tabrn == 1 && !ftab->makedir(pa, dn))
					textView->showText(LANG_ERROR, LANG_RENAME_DIREXISTS, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				else if (tabrn == 2 && !stab->makedir(pa, dn))
					textView->showText(LANG_ERROR, LANG_RENAME_DIREXISTS, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				else
				{
					if(tabrn == 1)
						ftab -> setDir(pa,ftab->getActItem());
					else if(tabrn == 2)
						stab -> setDir(pa,stab->getActItem());
				}
			}
		}
	}

QStringList FM::GetFilesInFolder(const QString &path)
{
	//recursive
	QDir dir ( path );
	QStringList::Iterator it;
	QStringList fullFiles;
	QStringList files = dir.entryList ( "*", QDir::Files );
	it = files.begin();
	while(it!=files.end())
	{
		fullFiles += QFileInfo ( path, *it ).filePath();
		++it;
	}
	QStringList dirs = dir.entryList ( QDir::Dirs );
	it = dirs.begin();
	while(it!=dirs.end())
	{
		if (*it!="." && *it!="..")
			fullFiles+=GetFilesInFolder(path + "/" + *it);
		++it;
	}
	return fullFiles;  
}

int FM::GetDirSize ( const QString &path )
{
	QString temp_processing;
	folder_num++;
	int size = 0;
	QDir dir(path);
	
	/** VARIANT 1*/
	QFileInfo		fi;
	DIR				*dp;
	struct dirent	*file;
	
	dp = opendir( QFile::encodeName(path) );
	while ( (file = readdir(dp)) != NULL ) 
	{
		if ( strcmp(file->d_name,"." ) == 0 || strcmp(file->d_name,".." ) == 0 )
			continue;

		QString fn = QFile::decodeName(file->d_name);
		fi.setFile( dir, fn );
		a->processEvents();
		if(processView->breaking)///ProcessScreen->breaking
			break;
		if (fi.isFile())
		{
			size+=fi.size();
			file_num++;
		}
		else if (fi.isDir())
		{
			size+=GetDirSize(fi.absFilePath());
		}	    
	}
	/** END VARIANT 1*/
	
	/** VARIANT 2 *
	QStringList::Iterator it;	
	
	QStringList files = dir.entryList ( "*", QDir::Files );
	it = files.begin();
	while ( it != files.end() )
	{
		if(!QFileInfo(path, *it).isSymLink())
		{
			size += QFileInfo(path, *it).size();
			file_num++;
			a->processEvents();
		}
		++it;
		if(processView->breaking)///ProcessScreen->breaking
			break;
	}
	QStringList dirs = dir.entryList ( QDir::Dirs );
	it = dirs.begin();
	while ( it != dirs.end())
	{
		if(!QFileInfo(path, *it).isSymLink())
		{
			if ( *it != "." && *it != ".." )
			size += GetDirSize ( path + "/" + *it );
		}
		++it;
		
		if(processView->breaking)///ProcessScreen->breaking
			break;
	}
	** END VARIANT 2*/
	return size;
}

QString FM::countSize(double size)
{
	if (size < 1024)
		return QString("%1 b").arg(size);
	else if (size < 1024 * 1024)
		return QString("%1 Kb").arg(floor(size/1024*100)/100);///(double)
	else
		return QString("%1 Mb").arg(floor(size/1024/1024*100)/100);///(double)
}

void FM::slot_Properties()
	{
		QString fn=getActiveFileName();
		
		if(fn!="..")
		{
			QFileInfo *qf = new QFileInfo(fn);
			
			QString fprops;
			fprops += " "+LANG_TYPE+": ";
			if (qf->isSymLink())
				{fprops +=LANG_SYMLINK;}
			else if (qf->isDir())
				fprops +=LANG_FOLDER;
			else if (qf->isFile())
				fprops +=LANG_FILE;
			else fprops +=LANG_UNK;
			
			fprops += "\n "+LANG_NAME+": "+getFileName(fn);
			
			fprops += "\n "+LANG_PATH+": "+fn;
			if(qf->isSymLink())
				{fprops +="\n LinkPath: "+qf->readLink();}
			
			fprops +="<hr> "+LANG_SIZE+": ";
			
			if (qf->isDir())
			{
				folder_num=-1;file_num=0;
				processView->showProcess(LANG_PROPERTIES, fprops+"...", Qt::AlignLeft, "", 0, IDB_IMAGE_PROPS, true);
				///ProcessScreen->start(LANG_PROPERTIES, fprops+"...", 0, NULL, 0, IDB_IMAGE_PROPS, true);
				unsigned long size=GetDirSize(fn);
				processView->init();///ProcessScreen->stop();
				QString b="";
				if(processView->breaking)///ProcessScreen->breaking
					b=">";
				fprops+=b;
				fprops+=countSize(size);
				if(size > 1024)
					fprops+=QString(" ("+b+"%1 b)").arg(size);					
				fprops += QString("\n "+LANG_DIRS+": "+b+"%1 | "+LANG_FILES+": "+b+"%2").arg(folder_num).arg(file_num);
			}
			else
			{
				unsigned long size = qf->size();
				
				fprops+=countSize(size);
				if(size > 1024)
					fprops+=QString(" (%1 b)").arg(size);	
			}
			
			fprops += "<hr> "+LANG_OWNER+": "+qf->owner();
			
			QString rights = "";
			if (qf->permission(QFileInfo::ReadUser)) rights="R";
			else rights="-";
			if (qf->permission(QFileInfo::WriteUser)) rights.append("W");
			else rights.append("-");
			if (qf->permission(QFileInfo::ExeUser)) rights.append("X");
			else rights.append("-");
			rights.append(" ");
			if (qf->permission(QFileInfo::ReadGroup)) rights.append("R");
			else rights.append("-");
			if (qf->permission(QFileInfo::WriteGroup)) rights.append("W");
			else rights.append("-");
			if (qf->permission(QFileInfo::ExeGroup)) rights.append("X");
			else rights.append("-");
			rights.append(" ");
			if (qf->permission(QFileInfo::ReadOther)) rights.append("R");
			else rights.append("-");
			if (qf->permission(QFileInfo::WriteOther)) rights.append("W");
			else rights.append("-");
			if (qf->permission(QFileInfo::ExeOther)) rights.append("X");
			else rights.append("-");
			
			fprops += "\n "+LANG_PERM+": "+rights;
			
			textView->showText(LANG_PROPERTIES, fprops, Qt::AlignLeft, IDB_IMAGE_PROPS, 1);
		}
	}

void FM::slot_BookMark()
	{
		int i=bookmark_menu->getActiveItemId();
		
		if(tabrn == 1)
		{
			ftab->setDir(bm_path[i],0);
		}
		if(tabrn == 2)
		{
			stab->setDir(bm_path[i],0);
		}
	}

void FM::slot_AddBookMark()
{
	textInput->LineText="";
	if(textInput->showText(LANG_BOOKMARK, LANG_ADD_BOOKMARK+":", IDB_IMAGE_BOOKMARK))
	{
		QString path, name;
		name=textInput->LineText;
		if(name=="" || name.left(1)==" ")
			name="BookMark";
		
		if(tabrn == 1)
			path = ftab -> getFilePath();
		else if(tabrn == 2)
			path = stab -> getFilePath();
	
		QFile file(work_folder+"/bookmark.cfg");
		if (file.open(IO_ReadWrite))
		{
			QTextStream stream ( &file );
			QString temp_line=stream.read();
			stream.setEncoding ( QTextStream::UnicodeUTF8 );
			stream << "\n" << name << "\n" << path;
			file.close();
		}
		
		bm_name.append(name);
		bm_path.append(path);
	
		int i=bookmark_menu->getActiveItemId();
	
		bookmark_menu->changeItem(i, bm_name[i], NULL);
		bookmark_menu->disconnectItem(i, this, SLOT(slot_AddBookMark()));
		bookmark_menu->connectItem(i, this, SLOT(slot_BookMark()));
	
		i++;
		QPixmap* pm = new QPixmap();
		pm->load(work_folder+IDB_IMAGE_ADD);
		bookmark_menu->insertItem("\t\t\t"+LANG_ADD_BOOKMARK, NULL, pm, true, i, i);
		bookmark_menu->connectItem(i, this, SLOT(slot_AddBookMark()));
	}
}

#include <SHARE_Tool.h>

void FM::slot_SendBt()
{
	QString file = getActiveFileName();
	QFileInfo *fi = new QFileInfo(file);
	if(fi->isFile())
	{
		SHARE_Tool::OBJECT_INFO info;
		info.n = file.right( file.findRev("/")!=-1?(file.length()-file.findRev("/")):file.length() );
		info.t = "media/"+getMime(file);
	
		if(!SHARE_Tool::shareByBt(info, file))
			textView->showText(LANG_ERROR, "Error send file "+file, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
	}
	else
		textView->showText(LANG_ERROR, "Error can't send "+file, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
}

void FM::drawAbout()
	{
		QFont ftitle("KolertsFont",27,87,false);
		QFont font("KolertsFont",15,10,false);
		
		about_widget=QPixmap(240, 320);
		QPixmap about_icon=QPixmap(ProgDir+"fm.png");
		
		QPainter p;	
		p.begin( &about_widget ,this);
		
		p.fillRect(0, 0, 240, 320, Qt::black);
		
		p.drawPixmap(7, 15, about_icon);	
		
		p.setFont(ftitle);
		p.setPen(QColor(255,100,12));
		p.drawText(70, 40, title, -1, QPainter::RTL);
		
		p.setFont(font);
		p.setPen(Qt::white);
		p.drawText(70, 60, text1, -1, QPainter::RTL);
		
		p.drawText(0, 115, 240, 20, Qt::AlignCenter, text2, -1, 0);
		//p.drawText(7, 150, Rus(text2), -1, QPainter::RTL);
		p.drawText(0, 140, 240, 20, Qt::AlignCenter, text3, -1, 0);
		//p.drawText(7, 175, Rus(text3), -1, QPainter::RTL);
		p.drawText(0, 205, 240, 20, Qt::AlignCenter, text4, -1, 0);
		//p.drawText(7, 280, Rus(text4), -1, QPainter::RTL);
		
		p.end();
	}
	
bool FM::ypoCkhc()
	{
		bool ret=true;
		
		title=QString("FsMan 1.6");
		text1=QString("FileManager for ROKR E2");
		
		char txt2[35] =
		{
			(char)40,	(char)99,	(char)41,	(char)32,	(char)87,	(char)114,	(char)105,	(char)116,	(char)116,
			(char)101,	(char)110,	(char)32,	(char)98,	(char)121,	(char)32,	(char)83,	(char)116,	(char)114,
			(char)101,	(char)108,	(char)111,	(char)107,	(char)32,	(char)86,	(char)108,	(char)97,	(char)100,
			(char)32,	(char)75,	(char)111,	(char)108,	(char)101,	(char)114,	(char)116,	(char)115
		};
		
		char txt3[18] =
		{
			(char)97,	(char)100,	(char)109,	(char)105,	(char)110,	(char)64,	(char)109,	(char)111,	(char)98,
			(char)115,	(char)107,	(char)46,	(char)111,	(char)114,	(char)103,	(char)46,	(char)117,	(char)97
		};
		
		char txt4[17] =
		{
			(char)104,	(char)116,	(char)116,	(char)112,	(char)58,	(char)47,	(char)47,	(char)77,	(char)111,
			(char)116,	(char)111,	(char)70,	(char)97,	(char)110,	(char)46,	(char)82,	(char)85
		};
		
		for(int i=0; i<35; i++)
		{
			text2+=QString("%1").arg(txt2[i]);
		}
		
		for(int i=0; i<18; i++)
		{
			text3+=QString("%1").arg(txt3[i]);
		}
		
		for(int i=0; i<17; i++)
		{
			text4+=QString("%1").arg(txt4[i]);
		}
		
		//(c) Written by Strelok Vlad Kolerts
		
		/*if(title.mid( 5, 2 )!="ew" && ret) ret=false;
		if(text1.mid( 4, 1 )!="v" && ret) ret=false;
		if(text1.mid( 11, 1 )!="f" && ret) ret=false;*/
		
		if(text2.mid( 18, 1 )!="e" && ret) ret=false;
		if(text2.mid( 25, 1 )!=QString("%1").arg((char)97) && ret) ret=false;
		if(text3.mid( 6, 1 )!="m" && ret) ret=false;
		if(text3.mid( 10, 1 )!=QString("%1").arg((char)107) && ret) ret=false;
		if(text4.mid( 15, 2 )!=QString("%1%2").arg((char)82).arg((char)85) && ret) ret=false;
		
		return ret;
	}
	
// ----------------------------Плагины:
// поиск
bool FM::searchPlugin(QString plug_name)
	{
		if (u->fExist(QString("%1/plugins/"+plug_name+"/"+plug_name).arg(work_folder)))
			return true;
		else
			return false;
	}
// запуск
void FM::slot_OpenWith()
	{
		push_green=false;
		///ProcessScreen->start("Processing..", NULL, 0, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);
		processView->showProcess("Processing..", "", 0, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_OPEN_WITH, false);
		
		int i=0;
		if(push_but==0) i=open_with_menu->getActiveItemId();
		else {i=push_but-1; push_but=0;}
		QString fto;
		if(tabrn == 1)		fto = ftab->getFileName();
		else if(tabrn == 2)	fto = stab->getFileName();
		
		QFileInfo *fi = new QFileInfo(fto);
		if(fi->isFile() /*&& fi->isExecutable()*/)
		{
			if (plugins[i].type==0)
			{
				if (searchPlugin(plugins[i].name))
				{
					system(work_folder+"/plugins/"+plugins[i].name+"/"+plugins[i].name+" -d "+ExecFormat(fto)+"&");
					/*char args[2];
					args[1] = "-d";
					args[2] = (char*)fto.utf8().data(); //ExecFormat(fto)
					qDebug(QString("arg2: %1").arg(args[2]));
					pid_t pid;						
					pid = fork ();
					if (pid == 0)
					{
						execv(work_folder+"/plugins/"+plugins[i].name+"/"+plugins[i].name, args);
						_exit (EXIT_FAILURE);
					}*/
				}
				else textView->showText(LANG_ERROR, "Can not find "+plugins[i].name, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
			}
			if (plugins[i].type==1)
			{
				system(plugins[i].name+" "+ExecFormat(fto)+"&");
			}
		}
		else textView->showText(LANG_ERROR, fto+" not executable", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
		
		///ProcessScreen->stop(25);
		processView->stop(25);
	}

	
void FM::slot_ClickFile(bool x)
	{
		if(x)
		{
			///ProcessScreen->start("Processing..", NULL, 0, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);
			processView->showProcess("Processing..", "", 0, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_OPEN_WITH, false);
			
			bool mime_finded=false;
			QString mime;
			QString fto;
			if(tabrn == 1)		fto = ftab -> getFileName();
			else if(tabrn == 2)	fto = stab -> getFileName();
			QFileInfo *fi = new QFileInfo(fto);
			if(fi->isFile() /*&& fi->isExecutable()*/)
			{
				mime=getMime(fto);
				
				for (int i=0;i<mime_nums;i++)
				{
					if(mime==mimes[i].type)
					{
						for(int j=0;j<plug_nums;j++)
						{
							if(mimes[i].app==plugins[j].id)
							{
								if (plugins[j].type==0 or 2)	system(work_folder+"/plugins/"+plugins[j].name+"/"+plugins[j].name+" -d "+ExecFormat(fto)+"&");
								if (plugins[j].type==1 or 3)	system(plugins[j].name+" "+ExecFormat(fto)+"&");
							}
						}
						mime_finded=true;
					}
				}
				if (!mime_finded)
				{
					///ProcessScreen->stop();
					processView->init();
					textView->showText(LANG_ERROR, "Don`t known how to open "+fto, Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				}
			}
			else
			{
				///ProcessScreen->stop();
				processView->init();
				textView->showText(LANG_ERROR, fto+" not executable", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
			}
			///ProcessScreen->stop(25);
			processView->stop(25);
		}
	}
	
void FM::SVKPlayer()
	{
		if(QCopChannel::isRegistered("SVKPlayer"))
		{
			QCopChannel::send("SVKPlayer", "show");
		}
		else
		{
			QString fto;QStringList ftos;
			bool multi_sel=false;
			QFileInfo fi;
			
			fto=getActiveFileName();
			
			if(getActiveMultiStat())
			{
				ftos=getActiveFileNames();
				
				if(ftos.count()>0)
					multi_sel=true;
			}
			
			if(multi_sel)
			{
				///ProcessScreen->start("Processing..", "Generate playlist...", 1, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);
				processView->showProcess("Processing..", "Generate playlist...", Qt::AlignHCenter, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_OPEN_WITH, false);
				QFile f(work_folder+"/plugins/SVKPlayer/TempList.m3u");
				if (f.exists())
					f.remove();
					
				for(int i=0;i<=(int)ftos.count();i++)
				{
					fi=QFileInfo(ftos[i]);
					if(fi.isDir())
						system("find "+ExecFormat(ftos[i])+" -type f -name *.mp3 -print | sort >> "+work_folder+"/plugins/SVKPlayer/TempList.m3u");
					else
						system("echo "+ExecFormat(ftos[i])+" >> "+work_folder+"/plugins/SVKPlayer/TempList.m3u");
				}
				system(work_folder+"/plugins/SVKPlayer/SVKPlayer -d "+work_folder+"/plugins/SVKPlayer/TempList.m3u"+" &");
				//ProcessScreen->stop(15);
				processView->stop(15);
			}
			else
			{
				fi=QFileInfo(fto);
				if(fi.isDir() /*&& fi->isExecutable()*/)
				{
					///ProcessScreen->setText("Gen. playlist...");				
					///ProcessScreen->start("Processing..", "Generate playlist...", 1, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);
					processView->showProcess("Processing..", "Generate playlist...", Qt::AlignHCenter, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_OPEN_WITH, false);
					a->processEvents();
					system("find "+ExecFormat(fto)+" -type f -name *.mp3 -print | sort > "+work_folder+"/plugins/SVKPlayer/TempList.m3u");
					system(work_folder+"/plugins/SVKPlayer/SVKPlayer -d "+work_folder+"/plugins/SVKPlayer/TempList.m3u"+" &");
					///ProcessScreen->stop(15);
					///ProcessScreen->hide();
					processView->stop(15);
				}
				else
				{
					system(work_folder+"/plugins/SVKPlayer/SVKPlayer -d "+ExecFormat(fto)+"&");
				}
			}
		}
	}
/// --------------------------------------------------------

void FM::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
		if (!push_green)
		{
			switch(k->key())
			{
				case KEY_GREEN:// 
					push_green=true;
				break;
				
				case KEY_RED:
					hide();
				break;
				
				case 48://	(0)
					if(tabrn == 1)
					{
						ftab->switchMultiSelect();
						ftab->setDir(ftab->getFilePath(),ftab->getActItem());
					}
					if(tabrn == 2)
					{
						stab->switchMultiSelect();
						stab->setDir(stab->getFilePath(),stab->getActItem());
					}					
				break;
				
				case 35://	(#)
					ftab->setFullInf();
					stab->setFullInf();
					ftab->setDir(ftab->getFilePath(),ftab->getActItem());
					stab->setDir(stab->getFilePath(),stab->getActItem());
				break;
				
				case 42://	(*)
					//if(full_scr)	{/*setFullScreenMode(true, true);*/fullScreenModeChanged(true);		full_scr=false;}
					//else			{/*setFullScreenMode(false, false);*/fullScreenModeChanged(false);	full_scr=true;}
					full_scr=!full_scr;
					fullScreenModeChanged(full_scr);
				break;
				
				case 4169://	(play)
					if (searchPlugin("SVKPlayer"))
					{
						SVKPlayer();
					}
					else textView->showText(LANG_ERROR, "Please install SVKPlayer", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				break;
				
				case 4172://	(next)
					if (searchPlugin("SVKPlayer"))
					{
						if(QCopChannel::isRegistered("SVKPlayer"))
							QCopChannel::send("SVKPlayer", "next");
					}
					else textView->showText(LANG_ERROR, "Please install SVKPlayer", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				break;
				
				case 4171://	(prew)
					if (searchPlugin("SVKPlayer"))
					{
						if(QCopChannel::isRegistered("SVKPlayer"))
							QCopChannel::send("SVKPlayer", "prew");
					}
					else textView->showText(LANG_ERROR, "Please install SVKPlayer", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				break;
				
				default:
				break;
			}
		}
		
		if(push_green)
		{
			switch(k->key())
			{
				case KEY_RED:
					CloseProgramm();
					push_green=false;
				break;
				
				case 35://	(#)
					///processView->showProcess(LANG_PROPERTIES, "Please wait", Qt::AlignLeft, "testing...", 0, IDB_IMAGE_PROPS, true);
					push_green=false;
				break;
				
				case 1+48:
					push_but=1;
					slot_OpenWith();
				break;
				
				case 2+48:
					push_but=2;
					slot_OpenWith();
				break;
				
				case 3+48:
					push_but=3;
					slot_OpenWith();
				break;
				
				case 4+48:
					push_but=4;
					slot_OpenWith();
				break;
				
				case 5+48:
					push_but=5;
					slot_OpenWith();
				break;
				
				case 6+48:
					push_but=6;
					slot_OpenWith();
				break;
				
				case 7+48:
					push_but=7;
					slot_OpenWith();
				break;
				
				case 8+48:
					push_but=8;
					slot_OpenWith();
				break;
				
				case 9+48:
					push_but=9;
					slot_OpenWith();
				break;
				
				case 4169://	(play)
					push_green=false;
					if (searchPlugin("SVKPlayer"))
					{
						if(QCopChannel::isRegistered("SVKPlayer"))
							QCopChannel::send("SVKPlayer", "show");
						else
						{
							///ProcessScreen->start("Processing..", NULL, 0, LANG_PLEASE_WAIT, 1, IDB_OPEN_WITH, false);
							processView->showProcess("Processing..", "", 0, LANG_PLEASE_WAIT, Qt::AlignHCenter, IDB_OPEN_WITH, false);
							system(work_folder+"/plugins/SVKPlayer/SVKPlayer -d "+work_folder+"/plugins/SVKPlayer/TempList.m3u"+" &");
							///ProcessScreen->stop(15);
							processView->stop(15);
						}
					}
					else textView->showText(LANG_ERROR, "Please install SVKPlayer", Qt::AlignHCenter, IDB_IMAGE_ERROR, 1);
				break;
				
				default:
				break;
			}
		}		
	}
	
void FM::CloseProgramm()
	{
		if (textView->showText(LANG_EXIT, LANG_EXIT_SURE, Qt::AlignHCenter, IDB_IMAGE_WARNING, 2))
		{
			a->quit();
		}
	}
	
void FM::slotQCopReceived(const QCString &msg)
{
	if (msg == "show()") a->raise();
	if (msg == "show_()") this->show();
}

void FM::keyReleaseEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
		switch(k->key())
		{
			case KEY_GREEN:// 
				push_green=false;
			break;
			
			default:
			break;
		}		
	}
