//
// Author: Strelok Vlad Kolerts, (C) 2009
//
// 

#include "TextInput.h"
#include "QDaemonApp.h"
extern QDaemonApp* a;

class TextInput;

TextInput::TextInput(QString progDir) : QWidget(NULL, "TextInput")
{
	setBackgroundMode(NoBackground);
	resize( 240, 320 );
	
	ProgDir = progDir;
	lCopy="\t\t\tCopy";
	lPaste="\t\t\tPaste";
	lYes="Yes";
	lNo="No";
	///scroll=0;
	
	panel = new QScrollView(this, "TextInput", 0);
	panel->setHScrollBarMode(QScrollView::AlwaysOff); 
	panel->setVScrollBarMode(QScrollView::AlwaysOff); //Auto
	panel->setFixedWidth(220);

	Label = new QLabel(panel);
	Label->setFixedWidth(220);
	
	line = new ZMultiLineEdit(panel, false, 1, "ZLineEdit");
	line->setFixedWidth(215);
	//line->setFixedHeight(font().pixelSize()+8);
	//line->setCellHeight(font().pixelSize()+8);
	//line->setMaxLines(1);
	//line->setAutoUpdate(true);
	//line->undoAvailable(true);
}

void TextInput::Init()
	{
		QRect rect;
		QPixmap pm;
		menu = new ZOptionsMenu(rect, NULL, NULL, 0);
		///menu->insertItem("Mark", NULL, NULL, true, 1, 1);
		pm.load(ProgDir+"res/img/copy.png");
		menu->insertItem(lCopy, NULL, &pm, true, 2, 2);
		///menu->insertItem("Cut", NULL, NULL, true, 3, 3);
		pm.load(ProgDir+"res/img/paste.png");
		menu->insertItem(lPaste, NULL, &pm, true, 4, 4);
		///menu->connectItem(1, this, SLOT(Mark()));
		menu->connectItem(2, this, SLOT(Copy()));
		///menu->connectItem(3, this, SLOT(Cut()));
		menu->connectItem(4, this, SLOT(Paste()));
		
		softLabel="<br><br><br><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#000000\"><tr>";
		softLabel+="<td align=\"center\" ><font size=\"3\" color=\"#eeeeee\">"+lYes+"</font></td>";
		softLabel+="<td align=\"center\" ><font size=\"3\" color=\"#eeeeee\">"+lNo+"</font></td>";
		softLabel+="</tr></table>";
	}

bool TextInput::showText(QString titl, QString txt, QString icon)
	{
		reply=true;
		question=true;
		menu->hide();
		///m_x=-1;m_y=-1;isMarked=false;
		
		QString pm;		
		if(icon!=NULL)pm="<img src="+ProgDir+QString("%1 ><br>").arg(icon);
		QString text="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#000000\"><tr><td align=\"center\" >";
		text+=pm+"<font size=\"4\" color=\"#eeeeee\"><b>"+titl+"</b></font>";
		text+="</td></tr></table>";
		
		text+="<p align=\"center\" >"+txt+"</p>";
		
		line->setText(LineText);
		line->selectAll();
		
		Label->setText(text);
		
		int h=Label->heightForWidth(220);
		
		panel->addChild(Label, 0, 0);
		panel->moveChild(line, 1, h);
		
		text+=softLabel;
		Label->setText(text);
		h=Label->heightForWidth(220);
		Label->setFixedHeight(h);
		panel->setFixedHeight(h);
		
		if(h<300)
		{
			panel->setFixedHeight(h);
			panel->move(10, (320-h)/2);
			//menu->move(10,(320-h)/2);
			QRect rect(10, (320-h)/2, menu->width(), menu->height());
			menu->setLimitRect(rect);
		}
		else
		{
			panel->setFixedHeight(300);
			panel->move(10, 10);
			menu->move(10, 10);
		}
		
		show();
		
		while	(question)
		{
			a->processEvents();
			/**if(isMarked)
			{
				int me_x = 0;
				int me_y = 0;
				line->getCursorPosition( &me_x, &me_y );
				line->setSelection( m_x, m_y,  me_x,  me_y );
			}*/
		}
		LineText=line->text();
		
		return reply;
	}
/**	
void TextInput::Mark()
	{
		if(isMarked)
		{
			m_x = m_y = -1;
			isMarked=false;
		}
		else
		{
			line->getCursorPosition( &m_x, &m_y );
			isMarked=true;
		}
	}
*/
	
void TextInput::Copy()
	{
		line->copy();
		///isMarked=false;
	}
/**	
void TextInput::Cut()
	{
		line->cut();
		isMarked=false;
	}
*/
	
void TextInput::Paste()
	{
		line->paste();
		///isMarked=false;
	}

QString TextInput::getProgramDir ( const QString &AFileName )
{
  QString str = AFileName;
  int i = str.findRev ( "/" );
  str.remove ( i+1, str.length() - i );
  return str;
}

void TextInput::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
		qDebug(QString("KEY: %1").arg(k->key()));
		switch(k->key())
		{
			case 4115:
				/*scroll--;
				panel->scrollBy(0, scroll);*/
			break;
			case 4117:
				/*scroll++;
				panel->scrollBy(0, scroll);*/
			break;
			case 4116:
			break;
			case 4114:
			break;
			
			case 0x1038:
				if(question)	reply=true;
				question=false;
				hide();
			break;
			
			case 0x103a:
				if(question)	reply=false;
				question=false;
				hide();
			break;
			
			case 0x1030:
				menu->show();
			break;
			
			default:
				if(!question)
				{
					hide();
				}
			break;
		}		
	}
