//
// Author: Strelok Vlad Kolerts, (C) 2009
//
// 

#include "kWidget.h"

extern QDaemonApp* a;
extern QString work_folder;

extern QString LANG_YES;
extern QString LANG_NO;
extern QString LANG_CANCEL;

kWidget::kWidget() : QWidget(NULL, "kWidget")
{
	QPixmapCache::setCacheLimit(4096);
	
	ani_timer = new QTimer(this);
	connect(ani_timer, SIGNAL(timeout()), SLOT(aniUpdate()));
	
	init();
}

bool kWidget::showText(QString titl, QString txt, int align, QString icon, int type)
{
	pos=0;
	drawTitle(titl, icon);
	drawText(txt, align);//Qt::AlignHCenter
	if(type==2)
		drawSoftKeys(0);

	return Show(type);
}

void kWidget::showProcess(QString titl, QString txt, int align, QString txt1, int align1, QString icon, int can_break)
{
	pos=0;
	drawTitle(titl, icon);
	if(txt!="")
		drawText(txt, align);//Qt::AlignHCenter
	drawAniIcon();
	if(txt1!="")
		drawText(txt1, align1);//Qt::AlignHCenter
	if(can_break)
		drawSoftKeys(1);

	Show(can_break);
}

bool kWidget::Show(int type)
{
	showing=true;
	breaking=false;
	reply=true;
	if(!type)
		reply=false;
	question=false;
	if(type==2)
		question=true;
	
	repaint();

	QTimer::singleShot(10, this, SLOT(show()));
	a->processEvents();
	
	while(question)
	{
		a->processEvents();
	}

	return reply;
}

void kWidget::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
		if(reply)
		{
			switch(k->key())
			{
				case 4115:
					/**scroll--;
					panel->scrollBy(0, scroll);*/
				break;
				case 4117:
					/**scroll++;
					panel->scrollBy(0, scroll);*/
				break;
				case 4116:
				break;
				case 4114:
				break;
				
				case 0x1038:
					if(question)	reply=true;
					breaking=true;
					question=false;
					init();
				break;
				
				case 0x103a:
					if(question)	reply=false;
					breaking=true;
					question=false;
					init();
				break;
				
				default:
					if(!question)
					{
						breaking=true;
						init();
					}
				break;
			}
		}
	}

///	--------------------------------------------------------------------

void kWidget::drawTitle(QString text, QString icon)
{
	font=QFont("KolertsFont",15,87,false);
	setText(text);
	p.setFont(font);
	
	p.setPen(QColor("#000000"));
	p.setBrush(QColor("#000000"));	
	p.drawRect(0, pos, 220, (line_h+4)*Text.count()+4);
	pos+=4;
	
	QPixmap pm_icon(work_folder+icon);
	p.drawPixmap((220-pm_icon.width())/2, pos, pm_icon);
	pos+=pm_icon.height();
	
	p.setPen(QColor("#ffffff"));
	for(int i=0;i<(int)Text.count();i++)
	{
		p.drawText(5, pos, 210, line_h, Qt::AlignHCenter, Text[i], -1);
		pos+=line_h+4;
	}
}

void kWidget::drawText(QString text, int align)//Qt::AlignHCenter
{
	font=QFont("KolertsFont",13,25,false);
	p.setFont(font);
	setText(text);
	
	int hr_pos=text.find("<hr>");
	int hr_count=0;
	while(hr_pos!=-1)
	{
		hr_pos=text.find("<hr>", hr_pos+4);
		hr_count++;
	}
	hr_count+=Text.count();
	
	p.setPen(QColor("#000000"));
	p.setBrush(QColor("#ffffff"));	
	p.drawRect(0, pos, 220, (line_h+4)*hr_count+4);
	pos+=4;
	
	hr_pos=text.find("<hr>");
	while(hr_pos!=-1)
	{
		setText(text.left(hr_pos));
		hr_pos=text.find("<hr>");
		text.remove(0,hr_pos+4);
		
		for(int i=0;i<(int)Text.count();i++)
		{
			p.drawText(5, pos, 210, line_h, align, Text[i], -1);
			pos+=line_h+4;
		}
		
		p.drawLine(5, pos, 210, pos);
		pos+=4;
		
		hr_pos=text.find("<hr>");
	}
	
	setText(text);
	for(int i=0;i<(int)Text.count();i++)
	{
		p.drawText(5, pos, 210, line_h, align, Text[i], -1);
		pos+=line_h+4;
	}
}

void kWidget::drawSoftKeys(int type)
{
	font=QFont("KolertsFont",13,25,false);
	p.setFont(font);
	
	p.setPen(QColor("#000000"));
	p.setBrush(QColor("#000000"));	
	p.drawRect(0, pos, 220, 15);
	
	p.setPen(QColor("#ffffff"));
	if(type==0)
	{
		p.drawText(0, pos, 110, 15, Qt::AlignCenter, LANG_YES, -1);
		p.drawText(110, pos, 110, 15, Qt::AlignCenter, LANG_NO, -1);
	}
	if(type==1)
		p.drawText(0, pos, 220, 15, Qt::AlignCenter, LANG_CANCEL, -1);
	
	pos+=15;
}

void kWidget::drawAniIcon()
{
	ani_pm.load(work_folder+"res/img/process/0.png");
	ani_pos=pos;
	ani_i=1;
	ani_timer->start(80);
	
	p.setPen(QColor("#000000"));
	p.setBrush(QColor("#ffffff"));	
	p.drawRect(0, pos-1, 220, ani_pm.height()+6);
	
	
	p.drawPixmap((220-ani_pm.width())/2, pos, ani_pm);
	
	pos+=ani_pm.height()+4;
}

void kWidget::setText(QString str)
{
	//str.replace( QString("	"), QString::fromUtf8( "     " ));
	//str.replace( QRegExp("\10\13"), "\n");
	Text.clear();
	QFontMetrics fm(font);
	line_h=fm.height();
	int len=0;
	int _pos=0;
	int maxWidth = 210 - fm.maxWidth();
	int posTo=0;
	int spasePos=0;
	int spaseLen=0;
	while (_pos < (int)str.length())
	{
		posTo = str.find('\n',_pos);
		
		if (posTo < 0)
			posTo = str.length();
		spasePos = _pos;
		spaseLen = 0;
    	len=0;
    	for(int i=_pos; i<posTo; i++)
		{
			len += fm.width( str[i] );

			if(str[i] == ' ')
			{
				spasePos = i;
				spaseLen = len;
			}				
			if(len > maxWidth)
			{
				if(spasePos == _pos)
				{
					Text.append(str.mid(_pos, i-_pos+1));
					_pos = i+1;
					len = 0;
					spaseLen = 0;
				}else
				{
					Text.append(str.mid(_pos, spasePos-_pos));
					_pos = spasePos+1;
					len = len-spaseLen;
				}
				spasePos = _pos;
			}
		}
		
		if(_pos != posTo)
		{
			Text.append(str.mid(_pos,posTo-_pos));
		}

		_pos = posTo+1;
	}
}

void kWidget::focusOutEvent(QFocusEvent *)
{
	if(showing)
		repaint();
}

void kWidget::focusInEvent(QFocusEvent *)
{
	repaint();
}

void kWidget::repaint()
{
	QTimer::singleShot(1, this, SLOT(paint()));
}

void kWidget::paint()
{
	pm.resize(220, pos);
	resize(220, pos);
	move(10, (320-pos)/2);
	a->processEvents();
	
	bitBlt( this, 0, 0, &pm );
}

void kWidget::aniUpdate()
{
	QString file=work_folder+QString("res/img/process/%1.png").arg(ani_i);
	a->processEvents();
	if(!QPixmapCache::find(file, ani_pm))
	{
		ani_pm.load(file);
		QPixmapCache::insert(file, ani_pm);
	}
	bitBlt( this, (220-ani_pm.width())/2, ani_pos, &ani_pm );
	ani_i++;
	if(ani_i>7)
		ani_i=0;

	if(ani_c>0)
	{
		ani_c--;
		if(ani_c==0)
			init();
	}
}

void kWidget::stop(int c)
{
	ani_c=c;
}

void kWidget::init()
{
	a->processEvents();
	showing=false;
	ani_c=0;
	hide();
	p.end();
	ani_timer->stop();
	
	setBackgroundMode(NoBackground);
	resize( 220, 320 );
	move(10, 20);
	pos=0;
	pm=QPixmap(220, 320);
	p.begin( &pm ,this);
	a->processEvents();
}
